

#include "kosSyst.h"
#include "kosFile.h"
#include "mcsmemm.h"
#include "kos_func.h"

char debuf[256];

/*
CKosFile::CKosFile(char *fileName)
{
	//
	this->fileInfo.bufferPtr = new Byte[FILE_BUFFER_SIZE];
	//
	this->filePointer = 0;
	this->bufferPointer = 0;
	this->validBuffer = false;
	//
	strcpy( this->fileInfo.fileURL, fileName );
}


CKosFile::~CKosFile(void)
{
	//
	delete this->fileInfo.bufferPtr;
}


void CKosFile::ValidateBuffer()
{
	//
	if ( this->validBuffer )
	{
		//
		if ( this->filePointer < this->bufferPointer
			|| this->filePointer >= (this->bufferPointer + FILE_BUFFER_SIZE) )
		{
			//
			this->validBuffer = false;
		}
	}
}


void CKosFile::UpdateBuffer(void)
{
	//
	if ( ! this->validBuffer )
	{
		//
		this->fileInfo.OffsetLow = this->filePointer / OS_BLOCK_SIZE;
		this->fileInfo.OffsetHigh = 0;
		//
		this->bufferPointer = this->fileInfo.OffsetLow * OS_BLOCK_SIZE;
		//
		this->fileInfo.dataCount = FILE_BUFFER_BLOCKS;
		//
		this->fileInfo.rwMode = 0;
		//
		Dword rr = kos_FileSystemAccess( &(this->fileInfo) );
		this->validBuffer = ( rr == 0 );
	}
}


int CKosFile::Seek(int seekFrom, int seekStep)
{
	//
	switch ( seekFrom )
	{
	//
	case SEEK_SET:
		//
		this->filePointer = seekStep;
		break;
	//
	case SEEK_CUR:
		//
		this->filePointer += seekStep;
		break;
	}
	//
	this->ValidateBuffer();
	//
	return this->filePointer;
}


int	CKosFile::Read(Byte *targetPtr, int readCount)
{
	int bufferLeast, result;

	//
	result = 0;
	//
	do
	{
		//
		this->UpdateBuffer();
		//
		if ( ! this->validBuffer ) return result;
		//
		bufferLeast = FILE_BUFFER_SIZE - (this->filePointer - this->bufferPointer);
		//
		if ( bufferLeast > readCount ) bufferLeast = readCount;
		//
		if ( bufferLeast )
		{
			//
			memcpy(
				targetPtr,
				this->fileInfo.bufferPtr + (this->filePointer - this->bufferPointer),
				bufferLeast
				);
			//
			targetPtr += bufferLeast;
			readCount -= bufferLeast;
			this->filePointer += bufferLeast;
			//
			result += bufferLeast;
		}
		//
		this->ValidateBuffer();
	}
	while ( readCount > 0 );
	//
	return result;
}


int CKosFile::Write(Byte *sourcePtr, int writeCount)
{
	return 0;
}

*/





void * malloc(int num)
{
	return allocmem(num*2+1000);
}
void free(void *p)
{
	freemem(p);
}
double atof(const char *c)
{
	return convert((char*)c, NULL);
}
int getc(FILE *f)
{
	int a = 0;
	fread(f,&a,1);
	return a;
}
void ungetc(int c, FILE *f)
{
	f->filePointer--;
	fwrite(f,&c,1);
}
int fprintf(FILE* f, const char * c, ...)
{
	//  
	return 0;
}
int fflush(FILE* f)
{
	return 0;

}
/*
int strcmp(const char *f, const char *t)
{
	return 0;
}
*/
int fclose(FILE* f)
{
	//sprintf(debuf, "file close %S",&f->fileInfo.fileURL);
	//rtlDebugOutString(debuf);
	freemem(f);
	return 0;

}
FILE* fopen(const char * fn, const char * q)
{
	FILE *p;
	//sprintf(debuf, "file open %S",fn);
	//rtlDebugOutString(debuf);
	p=malloc(sizeof(FILE));
	memset(p,0,sizeof(FILE));
	strcpy(&p->fileInfo.fileURL, fn);
	p->result = 1;
	return p;
}
int strncmp(const char * f, const char * t, int c)
//   
{

	int i=0;
	while (*f && *t && i < c)
	{
		if (*f < *t)
			return 1;
		if (*f > *t)
			return -1;
		i++;
	}
	if (i < c)
	{
		if (*f == '\0')
			return 1;
		if (*t == '\0')
			return -1;
	}
	return 0;

}
int unlink(const char * fn)
{
	//  ,  
	return 0;
}
/*
int memcmp(const void * f, const void *t, int n)
{

	return 0;
}
*/
int strncpy(char *f, const char *t, int n) 
{
	int i=0;
	while (*t && i < n)
	{
		*f++=*t++;
		i++;
	}

	return 0;
}
void *realloc(void * pp, int nn)
{
	void *p = malloc(nn);
	memcpy(p,pp,nn);
	free(pp);
	return p;
}
int file_exists(const char * fn)
{
	FILE *f;
	int q;
	//rtlDebugOutString(fn);
	//sprintf(debuf, "file exists %S",fn);
	//rtlDebugOutString(debuf);

	f=fopen(fn,"");
	q=f->result;
	fclose(f);
	//sprintf(debuf, "file exist result %U",!q);
	//rtlDebugOutString(debuf);

	return !q;
}
int fread(FILE * f, void *b, int n)
{
	DWORD rr;

	f->fileInfo.rwMode = 0;
	f->fileInfo.dataCount = n;
	f->fileInfo.bufferPtr = (Byte*)b;
	rr=kos_FileSystemAccess(&f->fileInfo);

	//sprintf(debuf, "file read %S res %U",&f->fileInfo.fileURL,rr);
	//rtlDebugOutString(debuf);

	return 0;
}
int fwrite(FILE *f, void *b, int n)
{
	DWORD rr;
	f->fileInfo.rwMode = 3;
	f->fileInfo.dataCount = n;
	f->fileInfo.bufferPtr = (Byte*)b;
	rr=kos_FileSystemAccess(&f->fileInfo);

	if (rr==5)
	{
		f->fileInfo.rwMode = 2;
		rr=kos_FileSystemAccess(&f->fileInfo);
	}

	//sprintf(debuf, "file write %S res %U",&f->fileInfo.fileURL,rr);
	//rtlDebugOutString(debuf);

	return 0;
}
int fseek(FILE * f, int n, int q)
{
	f->filePointer = n;
	//sprintf(debuf, "file seek to %S %U",&f->fileInfo.fileURL,n);
	//rtlDebugOutString(debuf);

	return 0;
}
int ftruncate(FILE *fn, int t)
{
	//sprintf(debuf, "file truncate %S",&fn->fileInfo.fileURL);
	//rtlDebugOutString(debuf);
	return 0;
}
int fgetsize(FILE *fn)
{
	kosBDVK bdvk;
	Dword rr;

	//sprintf(debuf, "file get size %S",&fn->fileInfo.fileURL);
	//rtlDebugOutString(debuf);

	fn->fileInfo.rwMode = 5;
	fn->fileInfo.bufferPtr = (Byte *)&bdvk;
	rr = kos_FileSystemAccess(&fn->fileInfo);

	sprintf(debuf, "file get size res %U",bdvk.size_low);
	//rtlDebugOutString(debuf);

	return bdvk.size_low;

}
int Kos_Sleep(int ms)
{
	return 0;

}



