

#pragma once

//#include <stdarg.h>

typedef unsigned __int32 Dword;
typedef unsigned __int16 Word;
typedef unsigned __int8 Byte;

typedef struct MemBlock
{
  Dword Size;
  Dword Addr;
  struct MemBlock *Next;
  struct MemBlock *Previous;
} MemBlock;

#define ERROR 8888888888.9
#define ERROR_END 8888888888.7

#define PREC 2

#define assert(exp)     ((void)0)

#define toupper(a) (((a)>='a' && (a)<'z')?(a)+0x20:(a))
#define tolower(a) (((a)>='A' && (a)<'Z')?(a)-0x20:(a))
#define isdigit(a) (((a)>='0') && ((a)<='9'))
#define islower(a) (((a)>='a') && ((a)<='z'))
#define isupper(a) (((a)>='A') && ((a)<='Z'))
#define isspace(a) (((a)==' ') || ((a)=='\t') || ((a)=='\n'))
#define isprint(a) ((a)>=0x20)
#define isalnum(a) (isdigit(a)||islower(a)||isupper(a))

void _chkstk(void);

typedef int HDC;
typedef int DWORD;

//typedef int int;
//typedef int size_t;

extern int SysColor;


typedef double (*function_t)(double);

typedef struct
{
  double x, y;
} TCoord;

typedef struct
{
	Dword attrib;
	Dword name_type;
	Dword create_time;
	Dword create_date;
	Dword access_time;
	Dword access_date;
	Dword modify_time;
	Dword modify_date;
	Dword size_low;
	Dword size_high;	
} kosBDVK;


#ifdef __cplusplus 
extern "C" {
#endif


Dword kos_GetSkinHeight();
Dword kos_GetSpecialKeyState();
void kos_GetMouseStateWnd( Dword * buttons, int * cursorX, int * cursorY );
void kos_DrawLine( Word x1, Word y1, Word x2, Word y2, Dword colour, Dword invert);
void DrawRegion(Dword x,Dword y,Dword width,Dword height,Dword color1);
int atoi(const char* string);

/*
double fabs(double x);
double cos(double x);
double sin(double x);
*/
int di(double x);

double id(int x);
//int isalpha(char c);
double __cdecl convert(char *s, int *len);
void format( char *Str, int len, char* Format, ... );

void line( int x1, int y1, int x2, int y2);

void outtextxy( int x, int y, char *s, int len);
void settextstyle( int a1, int a2, int a3);


double textwidth( char *s, int len);
double textheight( char *s, int len);
void setcolor( DWORD color);
void unsetcolor(HDC hdc);
void rectangle( int x1, int y1, int x2, int y2);




#ifdef __cplusplus 
}
#endif


